Index: tdomf.php
===================================================================
--- tdomf.php	(revision 169181)
+++ tdomf.php	(working copy)
@@ -411,7 +411,7 @@
 define("TDOMF_HIDE_REGISTER_GLOBAL_ERROR", false);
 
 define('TDOMF_OPTION_WIDGET_MAX_WIDTH',"tdomf_form_widget_max_width");
-define('TDOMF_OPTION_WIDGET_MAX_LENGTH',"tdomf_form_widget_max_length");
+define('TDOMF_OPTION_WIDGET_MAX_HEIGHT',"tdomf_form_widget_max_height");
 
 //////////////////
 // 0.10.3 Settings
@@ -552,280 +552,280 @@
 define('TDOMF_KEY_FIELDS', "_tdomf_fields");
 define('TDOMF_KEY_CUSTOM_FIELDS', "_tdomf_custom_fields");
 
-//////////////////////////////////////////////////
-// loading text domain for language translation
-//
-load_plugin_textdomain('tdomf',PLUGINDIR.DIRECTORY_SEPARATOR.TDOMF_FOLDER);
-
-/////////////////////////////////////////
-// Loading "hacks" here before pluggable
-//
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-hacks.php');
-
-//////////////////////////////////////////////////////////////////////////
-// A potential fix for WordpressMU (WordpressMU is officially unsupported)
-//
-require_once(ABSPATH . 'wp-includes/pluggable.php');
-
-// Is this a Wordpress < 2.5 install?
-//
-function tdomf_wp23() {
-  global $wp_db_version;
-  #if($wp_db_verison <= 6124)
-  #  return true;
-  return !tdomf_wp25();
-}
-
-// Is this a Wordpress >= 2.5 install?
-//
-function tdomf_wp25() {
-  global $wp_db_version;
-  if($wp_db_version >= 7558) {
-    return true;
-  }
-  return false;
-}
-
-// Is this a Wordpress >= 2.7
-//
-function tdomf_wp27() {
-  global $wp_version;
-  return version_compare($wp_version,"2.7-beta3",">=");
-}
-
-///////////////////////////////////
-// Configure Backend Admin Menus //
-///////////////////////////////////
-
-add_action('admin_menu', 'tdomf_add_menus');
-function tdomf_add_menus()
-{
-    $unmod_count  = tdomf_get_unmoderated_posts_count();
-    $unmod_count += tdomf_get_edits(array('state' => 'unapproved', 'count' => true, 'unique_post_ids' => true));
-
-    /*if(tdomf_wp25() && $unmod_count > 0) {
-        add_menu_page(__('TDO Mini Forms', 'tdomf'), sprintf(__("TDO Mini Forms <span id='awaiting-mod' class='count-%d'><span class='comment-count'>%d</span></span>", 'tdomf'), $unmod_count, $unmod_count), 'edit_others_posts', TDOMF_FOLDER, 'tdomf_overview_menu');
-    } else {*/
-        add_menu_page(__('TDO Mini Forms', 'tdomf'), __('TDO Mini Forms', 'tdomf'), 'edit_others_posts', TDOMF_FOLDER, 'tdomf_overview_menu');
-    /*}*/
-
-    // Options
-    add_submenu_page( TDOMF_FOLDER , __('Options', 'tdomf'), __('Options', 'tdomf'), 'manage_options', 'tdomf_show_options_menu', 'tdomf_show_options_menu');
-    //
-    // Form Options
-    add_submenu_page( TDOMF_FOLDER , __('Form Options', 'tdomf'), __('Form Options', 'tdomf'), 'manage_options', 'tdomf_show_form_options_menu', 'tdomf_show_form_options_menu');
-    //
-    // Form Widgets
-    add_submenu_page( TDOMF_FOLDER , __('Form Creator', 'tdomf'), __('Form Creator', 'tdomf'), 'manage_options', 'tdomf_show_form_menu', 'tdomf_show_form_menu');
-    //
-    // Form Hacker
-    add_submenu_page( TDOMF_FOLDER , __('Form Hacker', 'tdomf'), __('Form Hacker', 'tdomf'), 'manage_options', 'tdomf_show_form_hacker', 'tdomf_show_form_hacker');
-    //
-    // Form Export
-    add_submenu_page( TDOMF_FOLDER , __('Form Export', 'tdomf'), __('Form Export', 'tdomf'), 'manage_options', 'tdomf_show_form_export_menu', 'tdomf_show_form_export_menu');
-    //
-    // Moderation Queue
-    if(tdomf_is_moderation_in_use()) {
-      add_submenu_page( TDOMF_FOLDER , __('Moderation', 'tdomf'), sprintf(__('Moderation (%d)', 'tdomf'), $unmod_count), 'edit_others_posts', 'tdomf_show_mod_posts_menu', 'tdomf_show_mod_posts_menu');
-    }
-    else {
-      add_submenu_page( TDOMF_FOLDER , __('Moderation', 'tdomf'), __('Moderation', 'tdomf'), 'edit_others_posts', 'tdomf_show_mod_posts_menu', 'tdomf_show_mod_posts_menu');
-    }
-    //
-    // Manage Submitters
-    add_submenu_page( TDOMF_FOLDER , __('Users and IPs', 'tdomf'), __('Users and IPs', 'tdomf'), 'edit_others_posts', 'tdomf_show_manage_menu', 'tdomf_show_manage_menu');
-    //
-    // Log
-    add_submenu_page( TDOMF_FOLDER , __('Log', 'tdomf'), __('Log', 'tdomf'), 'manage_options', 'tdomf_show_log_menu', 'tdomf_show_log_menu');
-    //
-    // Uninstall
-    add_submenu_page( TDOMF_FOLDER , __('Uninstall', 'tdomf'), __('Uninstall', 'tdomf'), 'manage_options', 'tdomf_show_uninstall_menu', 'tdomf_show_uninstall_menu');
-
-    //
-    // Your submissions
-    if(get_option(TDOMF_OPTION_YOUR_SUBMISSIONS)) {
-      add_submenu_page('profile.php', 'Your Submissions', 'Your Submissions', 0, 'tdomf_your_submissions', 'tdomf_show_your_submissions_menu');
-    }
-}
-
-//////////////////////////////////
-// Load the rest of the plugin! //
-//////////////////////////////////
-
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-log-functions.php');
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-widget-functions.php');
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-template-functions.php');
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-spam.php');
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-form.php');
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-notify.php');
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-upload-functions.php');
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-theme-widgets.php');
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-db.php');
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-msgs.php');
-require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-widget-classes.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-overview.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-edit-post-panel.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-form-options.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-form-export.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-options.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-edit-form.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-log.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-moderation.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-manage.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-your-submissions.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-uninstall.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-form-hacker.php');
-require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-export.php');
-
-/////////////////////////
-// What's new since... //
-/////////////////////////
-
-function tdomf_new_features() {
-  $last_version = get_option(TDOMF_VERSION_LAST);
-  $features = "";
-
-  if($last_version == false) { return false; }
-
-  // 29 = 0.10.4
-  if($last_version <= 29) {
-
-    $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_options_menu#spam";
-    $features .= "<li>".sprintf(__('<a href="%s">Integration with Akismet for SPAM protection</a>','tdomf'),$link)."</li>";
-
-    $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_options_menu&form=".tdomf_get_first_form_id()."#queue";
-    $features .= "<li>".sprintf(__('<a href="%s">Automatically schedule approved posts!</a>','tdomf'),$link)."</li>";
-
-    $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_options_menu&form=".tdomf_get_first_form_id()."#throttle";
-    $features .= "<li>".sprintf(__('<a href="%s">Add submission throttling rules to your form!</a>','tdomf'),$link)."</li>";
-
-    if(current_user_can('manage_options')) {
-        $link = "admin.php?page=".TDOMF_FOLDER.DIRECTORY_SEPARATOR."admin".DIRECTORY_SEPARATOR."tdomf-info.php&text";
-        $link2 = "admin.php?page=".TDOMF_FOLDER.DIRECTORY_SEPARATOR."admin".DIRECTORY_SEPARATOR."tdomf-info.php&html";
-        $features .= "<li>".sprintf(__('View tdomfinfo() in <a href="%s">text</a> and <a href="%s">html-code</a>. Useful for copying and pasting!',"tdomf"),$link,$link2)."</li>";
-    }
-
-    $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_options_menu&form=".tdomf_get_first_form_id()."#import";
-    $features .= "<li>".sprintf(__('<a href="%s">Import and export individual form settings</a>','tdomf'),$link)."</li>";
-
-    $link = get_bloginfo('wpurl')."/wp-admin/widgets.php";
-    $features .= "<li>".sprintf(__('New widget for your theme: <a href="%s">Top Submitters</a>','tdomf'),$link)."</li>";
-  }
-  // 30 = 0.11b
-  // 31 = 0.11
-  // 32 = 0.11.1 (bug fixes)
-  if($last_version <= 32) {
-
-      $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_options_menu&form=".tdomf_get_first_form_id()."#ajax";
-      $features .= "<li>".sprintf(__('<a href="%s">AJAX support for forms!</a>','tdomf'),$link)."</li>";
-
-      $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_form_hacker";
-      $features .= "<li>".sprintf(__('<a href="%s">Hack the appearance of your form!</a>','tdomf'),$link)."</li>";
-
-      $link = get_bloginfo('wpurl')."/wp-admin/admin.phppage=tdomf_show_form_menu&form=".tdomf_get_first_form_id();
-      $features .= "<li>".sprintf(__('<a href="%s">Text widget updated to support macros and php code</a>','tdomf'),$link)."</li>";
-
-      $link = get_bloginfo('wpurl')."/wp-admin/admin.phppage=tdomf_show_form_menu&form=".tdomf_get_first_form_id();
-      $features .= "<li>".sprintf(__('<a href="%s">Categories widget can now be displayed as checkboxes or radio buttons</a>','tdomf'),$link)."</li>";
-
-      $link = get_bloginfo('wpurl')."/wp-admin/admin.phppage=tdomf_show_form_menu&form=".tdomf_get_first_form_id();
-      $features .= "<li>".sprintf(__('<a href="%s">New Widget: Append. Allows you add text to a submitted post. It can even run PHP code.</a>','tdomf'),$link)."</li>";
-
-      $features .= "<li>".__('New Template Tags: tdomf_get_the_submitter_email and tdomf_the_submitter_email','tdomf')."</li>";
-  }
-  // 33 = 0.12b
-  // 34 = 0.12
-  // 40 = 0.12.3
-  if($last_version < 40) {
-      $features .= "<li>".__("Auto Respond Email widget for your form","tdomf")."</li>";
-      $features .= "<li>".__("Ban User and IP links directly from the moderation email","tdomf")."</li>";
-      $features .= "<li>".__("The moderation emails that are sent for admins can now be left turned on even if moderation is turned off","tdomf")."</li>";
-  }
-  // 41 = 0.12.4
-  if($last_version < 41) {
-      $features .= "<li>".__("Improved Error Reporting","tdomf")."</li>";
-      $features .= "<li>".__("Form toolbar on all form pages (Widgets and Form Hacker)","tdomf")."</li>";
-      $features .= "<li>".__("Include option implemented for Categories widget","tdomf")."</li>";
-      $features .= "<li>".__("Import/Export restored and improved","tdomf")."</li>";
-      $features .= "<li>".__("Default Generated Forms are now W3C compliant","tdomf")."</li>";
-      $features .= "<li>".__("Comment Notification from Submitted Posts no longer go to the Submitter unless they can modify the comments","tdomf")."</li>";
-  }
-  // 43 = 0.12.5
-  if($last_version < 43) {
-      $features .= "<li>".__("Excerpt Widget","tdomf")."</li>";
-      $features .= "<li>".__("Comments Management Widget","tdomf")."</li>";
-      $features .= "<li>".__("Include option implemented for Categories widget (fixed)","tdomf")."</li>";
-      $features .= "<li>".__("Order by and Sort options for Categories widget","tdomf")."</li>";
-      $features .= "<li>".__("Integration with Subscribe to Comments plugin via widget","tdomf")."</li>";
-      $features .= "<li>".__("Publish now button","tdomf")."</li>";
-      $features .= "<li>".__("Specify Email Addresses instead of Roles to recieve Moderation notifications","tdomf")."</li>";
-      $features .= "<li>".__('Default tags, required and enable/disable user adding tags options for Tags widget','tdomf').'</li>';
-  }
-  // 44 = pre-0.13 release
-  if($last_version < 44) {
-      $features .= "<li>".__("More powerful form access configuration. Now you can select by capability and user as well as role!","tdomf")."</li>";
-      $features .= "<li>".__("2.7 Wordpress Compatibility","tdomf")."</li>";
-      $features .= "<li>".__("Can now turn off auto-publishing of users with publishing rights","tdomf")."</li>";
-      $features .= "<li>".__("New Permalink Widget","tdomf")."</li>";
-      $features .= "<li>".__("New GeoMashup Integration Widget","tdomf")."</li>";
-  }
-  // 46 = 0.12.7
-  if($last_version < 46) {
-      $features .= "<li>".__("Auto Respond Email widget can now provide a link to flag posts using a Custom Field","tdomf")."</li>";
-  }
-  // 47 = 0.13
-  if($last_version < 47) {
-      $features .= "<li>".__("<b>You can now created forms to edit posts and pages!</b>","tdomf")."</li>";
-  }
-  // 48 = 0.13.1
-  // 49 = 0.13.2
-  if($last_version < 49) {
-      $features .= "<li>".__("<b>More Spam Checking options added. Can now be configured per form!</b>","tdomf")."</li>";
-  }
-  // 50 = 0.13.3
-  if($last_version < 50) {
-      $features .= "<li>".__("<b>Filter by user, ip and form on moderations screen</b>","tdomf")."</li>";
-      $features .= "<li>".__("<b>Enable syntax code highlighting on Form Hacker and messages</b>","tdomf")."</li>";
-      $features .= "<li>".__("<b>Special revision page for comparing revisions created by TDOMF</b>","tdomf")."</li>";
-  }
-  // 51 = 0.13.4
-  
-  if(!empty($features)) {
-    return "<ul>".$features."</ul>";
-  }
-
-  return false;
-}
-
-/////////////////////////
-// Start/Init/Upgrade //
-////////////////////////
-
-function tdomf_init(){
-
-  // Pre 0.7 or a fresh install!
-  if(get_option(TDOMF_VERSION_CURRENT) == false)
-  {
-    add_option(TDOMF_VERSION_CURRENT,TDOMF_BUILD);
-
-    // Some defaults for new options!
-    add_option(TDOMF_OPTION_MODERATION,true);
-    add_option(TDOMF_OPTION_PREVIEW,true);
-    add_option(TDOMF_OPTION_TRUST_COUNT,-1);
-    add_option(TDOMF_OPTION_YOUR_SUBMISSIONS,true);
+//////////////////////////////////////////////////
+// loading text domain for language translation
+//
+load_plugin_textdomain('tdomf',PLUGINDIR.DIRECTORY_SEPARATOR.TDOMF_FOLDER);
+
+/////////////////////////////////////////
+// Loading "hacks" here before pluggable
+//
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-hacks.php');
+
+//////////////////////////////////////////////////////////////////////////
+// A potential fix for WordpressMU (WordpressMU is officially unsupported)
+//
+require_once(ABSPATH . 'wp-includes/pluggable.php');
+
+// Is this a Wordpress < 2.5 install?
+//
+function tdomf_wp23() {
+  global $wp_db_version;
+  #if($wp_db_verison <= 6124)
+  #  return true;
+  return !tdomf_wp25();
+}
+
+// Is this a Wordpress >= 2.5 install?
+//
+function tdomf_wp25() {
+  global $wp_db_version;
+  if($wp_db_version >= 7558) {
+    return true;
+  }
+  return false;
+}
+
+// Is this a Wordpress >= 2.7
+//
+function tdomf_wp27() {
+  global $wp_version;
+  return version_compare($wp_version,"2.7-beta3",">=");
+}
+
+///////////////////////////////////
+// Configure Backend Admin Menus //
+///////////////////////////////////
+
+add_action('admin_menu', 'tdomf_add_menus');
+function tdomf_add_menus()
+{
+    $unmod_count  = tdomf_get_unmoderated_posts_count();
+    $unmod_count += tdomf_get_edits(array('state' => 'unapproved', 'count' => true, 'unique_post_ids' => true));
+
+    /*if(tdomf_wp25() && $unmod_count > 0) {
+        add_menu_page(__('TDO Mini Forms', 'tdomf'), sprintf(__("TDO Mini Forms <span id='awaiting-mod' class='count-%d'><span class='comment-count'>%d</span></span>", 'tdomf'), $unmod_count, $unmod_count), 'edit_others_posts', TDOMF_FOLDER, 'tdomf_overview_menu');
+    } else {*/
+        add_menu_page(__('TDO Mini Forms', 'tdomf'), __('TDO Mini Forms', 'tdomf'), 'edit_others_posts', TDOMF_FOLDER, 'tdomf_overview_menu');
+    /*}*/
+
+    // Options
+    add_submenu_page( TDOMF_FOLDER , __('Options', 'tdomf'), __('Options', 'tdomf'), 'manage_options', 'tdomf_show_options_menu', 'tdomf_show_options_menu');
+    //
+    // Form Options
+    add_submenu_page( TDOMF_FOLDER , __('Form Options', 'tdomf'), __('Form Options', 'tdomf'), 'manage_options', 'tdomf_show_form_options_menu', 'tdomf_show_form_options_menu');
+    //
+    // Form Widgets
+    add_submenu_page( TDOMF_FOLDER , __('Form Creator', 'tdomf'), __('Form Creator', 'tdomf'), 'manage_options', 'tdomf_show_form_menu', 'tdomf_show_form_menu');
+    //
+    // Form Hacker
+    add_submenu_page( TDOMF_FOLDER , __('Form Hacker', 'tdomf'), __('Form Hacker', 'tdomf'), 'manage_options', 'tdomf_show_form_hacker', 'tdomf_show_form_hacker');
+    //
+    // Form Export
+    add_submenu_page( TDOMF_FOLDER , __('Form Export', 'tdomf'), __('Form Export', 'tdomf'), 'manage_options', 'tdomf_show_form_export_menu', 'tdomf_show_form_export_menu');
+    //
+    // Moderation Queue
+    if(tdomf_is_moderation_in_use()) {
+      add_submenu_page( TDOMF_FOLDER , __('Moderation', 'tdomf'), sprintf(__('Moderation (%d)', 'tdomf'), $unmod_count), 'edit_others_posts', 'tdomf_show_mod_posts_menu', 'tdomf_show_mod_posts_menu');
+    }
+    else {
+      add_submenu_page( TDOMF_FOLDER , __('Moderation', 'tdomf'), __('Moderation', 'tdomf'), 'edit_others_posts', 'tdomf_show_mod_posts_menu', 'tdomf_show_mod_posts_menu');
+    }
+    //
+    // Manage Submitters
+    add_submenu_page( TDOMF_FOLDER , __('Users and IPs', 'tdomf'), __('Users and IPs', 'tdomf'), 'edit_others_posts', 'tdomf_show_manage_menu', 'tdomf_show_manage_menu');
+    //
+    // Log
+    add_submenu_page( TDOMF_FOLDER , __('Log', 'tdomf'), __('Log', 'tdomf'), 'manage_options', 'tdomf_show_log_menu', 'tdomf_show_log_menu');
+    //
+    // Uninstall
+    add_submenu_page( TDOMF_FOLDER , __('Uninstall', 'tdomf'), __('Uninstall', 'tdomf'), 'manage_options', 'tdomf_show_uninstall_menu', 'tdomf_show_uninstall_menu');
+
+    //
+    // Your submissions
+    if(get_option(TDOMF_OPTION_YOUR_SUBMISSIONS)) {
+      add_submenu_page('profile.php', 'Your Submissions', 'Your Submissions', 0, 'tdomf_your_submissions', 'tdomf_show_your_submissions_menu');
+    }
+}
+
+//////////////////////////////////
+// Load the rest of the plugin! //
+//////////////////////////////////
+
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-log-functions.php');
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-widget-functions.php');
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-template-functions.php');
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-spam.php');
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-form.php');
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-notify.php');
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-upload-functions.php');
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-theme-widgets.php');
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-db.php');
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-msgs.php');
+require_once(TDOMF_FULLPATH.'include'.DIRECTORY_SEPARATOR.'tdomf-widget-classes.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-overview.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-edit-post-panel.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-form-options.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-form-export.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-options.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-edit-form.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-log.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-moderation.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-manage.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-your-submissions.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-uninstall.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-form-hacker.php');
+require_once(TDOMF_FULLPATH.'admin'.DIRECTORY_SEPARATOR.'tdomf-export.php');
+
+/////////////////////////
+// What's new since... //
+/////////////////////////
+
+function tdomf_new_features() {
+  $last_version = get_option(TDOMF_VERSION_LAST);
+  $features = "";
+
+  if($last_version == false) { return false; }
+
+  // 29 = 0.10.4
+  if($last_version <= 29) {
+
+    $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_options_menu#spam";
+    $features .= "<li>".sprintf(__('<a href="%s">Integration with Akismet for SPAM protection</a>','tdomf'),$link)."</li>";
+
+    $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_options_menu&form=".tdomf_get_first_form_id()."#queue";
+    $features .= "<li>".sprintf(__('<a href="%s">Automatically schedule approved posts!</a>','tdomf'),$link)."</li>";
+
+    $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_options_menu&form=".tdomf_get_first_form_id()."#throttle";
+    $features .= "<li>".sprintf(__('<a href="%s">Add submission throttling rules to your form!</a>','tdomf'),$link)."</li>";
+
+    if(current_user_can('manage_options')) {
+        $link = "admin.php?page=".TDOMF_FOLDER.DIRECTORY_SEPARATOR."admin".DIRECTORY_SEPARATOR."tdomf-info.php&text";
+        $link2 = "admin.php?page=".TDOMF_FOLDER.DIRECTORY_SEPARATOR."admin".DIRECTORY_SEPARATOR."tdomf-info.php&html";
+        $features .= "<li>".sprintf(__('View tdomfinfo() in <a href="%s">text</a> and <a href="%s">html-code</a>. Useful for copying and pasting!',"tdomf"),$link,$link2)."</li>";
+    }
+
+    $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_options_menu&form=".tdomf_get_first_form_id()."#import";
+    $features .= "<li>".sprintf(__('<a href="%s">Import and export individual form settings</a>','tdomf'),$link)."</li>";
+
+    $link = get_bloginfo('wpurl')."/wp-admin/widgets.php";
+    $features .= "<li>".sprintf(__('New widget for your theme: <a href="%s">Top Submitters</a>','tdomf'),$link)."</li>";
+  }
+  // 30 = 0.11b
+  // 31 = 0.11
+  // 32 = 0.11.1 (bug fixes)
+  if($last_version <= 32) {
+
+      $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_options_menu&form=".tdomf_get_first_form_id()."#ajax";
+      $features .= "<li>".sprintf(__('<a href="%s">AJAX support for forms!</a>','tdomf'),$link)."</li>";
+
+      $link = get_bloginfo('wpurl')."/wp-admin/admin.php?page=tdomf_show_form_hacker";
+      $features .= "<li>".sprintf(__('<a href="%s">Hack the appearance of your form!</a>','tdomf'),$link)."</li>";
+
+      $link = get_bloginfo('wpurl')."/wp-admin/admin.phppage=tdomf_show_form_menu&form=".tdomf_get_first_form_id();
+      $features .= "<li>".sprintf(__('<a href="%s">Text widget updated to support macros and php code</a>','tdomf'),$link)."</li>";
+
+      $link = get_bloginfo('wpurl')."/wp-admin/admin.phppage=tdomf_show_form_menu&form=".tdomf_get_first_form_id();
+      $features .= "<li>".sprintf(__('<a href="%s">Categories widget can now be displayed as checkboxes or radio buttons</a>','tdomf'),$link)."</li>";
+
+      $link = get_bloginfo('wpurl')."/wp-admin/admin.phppage=tdomf_show_form_menu&form=".tdomf_get_first_form_id();
+      $features .= "<li>".sprintf(__('<a href="%s">New Widget: Append. Allows you add text to a submitted post. It can even run PHP code.</a>','tdomf'),$link)."</li>";
+
+      $features .= "<li>".__('New Template Tags: tdomf_get_the_submitter_email and tdomf_the_submitter_email','tdomf')."</li>";
+  }
+  // 33 = 0.12b
+  // 34 = 0.12
+  // 40 = 0.12.3
+  if($last_version < 40) {
+      $features .= "<li>".__("Auto Respond Email widget for your form","tdomf")."</li>";
+      $features .= "<li>".__("Ban User and IP links directly from the moderation email","tdomf")."</li>";
+      $features .= "<li>".__("The moderation emails that are sent for admins can now be left turned on even if moderation is turned off","tdomf")."</li>";
+  }
+  // 41 = 0.12.4
+  if($last_version < 41) {
+      $features .= "<li>".__("Improved Error Reporting","tdomf")."</li>";
+      $features .= "<li>".__("Form toolbar on all form pages (Widgets and Form Hacker)","tdomf")."</li>";
+      $features .= "<li>".__("Include option implemented for Categories widget","tdomf")."</li>";
+      $features .= "<li>".__("Import/Export restored and improved","tdomf")."</li>";
+      $features .= "<li>".__("Default Generated Forms are now W3C compliant","tdomf")."</li>";
+      $features .= "<li>".__("Comment Notification from Submitted Posts no longer go to the Submitter unless they can modify the comments","tdomf")."</li>";
+  }
+  // 43 = 0.12.5
+  if($last_version < 43) {
+      $features .= "<li>".__("Excerpt Widget","tdomf")."</li>";
+      $features .= "<li>".__("Comments Management Widget","tdomf")."</li>";
+      $features .= "<li>".__("Include option implemented for Categories widget (fixed)","tdomf")."</li>";
+      $features .= "<li>".__("Order by and Sort options for Categories widget","tdomf")."</li>";
+      $features .= "<li>".__("Integration with Subscribe to Comments plugin via widget","tdomf")."</li>";
+      $features .= "<li>".__("Publish now button","tdomf")."</li>";
+      $features .= "<li>".__("Specify Email Addresses instead of Roles to recieve Moderation notifications","tdomf")."</li>";
+      $features .= "<li>".__('Default tags, required and enable/disable user adding tags options for Tags widget','tdomf').'</li>';
+  }
+  // 44 = pre-0.13 release
+  if($last_version < 44) {
+      $features .= "<li>".__("More powerful form access configuration. Now you can select by capability and user as well as role!","tdomf")."</li>";
+      $features .= "<li>".__("2.7 Wordpress Compatibility","tdomf")."</li>";
+      $features .= "<li>".__("Can now turn off auto-publishing of users with publishing rights","tdomf")."</li>";
+      $features .= "<li>".__("New Permalink Widget","tdomf")."</li>";
+      $features .= "<li>".__("New GeoMashup Integration Widget","tdomf")."</li>";
+  }
+  // 46 = 0.12.7
+  if($last_version < 46) {
+      $features .= "<li>".__("Auto Respond Email widget can now provide a link to flag posts using a Custom Field","tdomf")."</li>";
+  }
+  // 47 = 0.13
+  if($last_version < 47) {
+      $features .= "<li>".__("<b>You can now created forms to edit posts and pages!</b>","tdomf")."</li>";
+  }
+  // 48 = 0.13.1
+  // 49 = 0.13.2
+  if($last_version < 49) {
+      $features .= "<li>".__("<b>More Spam Checking options added. Can now be configured per form!</b>","tdomf")."</li>";
+  }
+  // 50 = 0.13.3
+  if($last_version < 50) {
+      $features .= "<li>".__("<b>Filter by user, ip and form on moderations screen</b>","tdomf")."</li>";
+      $features .= "<li>".__("<b>Enable syntax code highlighting on Form Hacker and messages</b>","tdomf")."</li>";
+      $features .= "<li>".__("<b>Special revision page for comparing revisions created by TDOMF</b>","tdomf")."</li>";
+  }
+  // 51 = 0.13.4
+  
+  if(!empty($features)) {
+    return "<ul>".$features."</ul>";
+  }
+
+  return false;
+}
+
+/////////////////////////
+// Start/Init/Upgrade //
+////////////////////////
+
+function tdomf_init(){
+
+  // Pre 0.7 or a fresh install!
+  if(get_option(TDOMF_VERSION_CURRENT) == false)
+  {
+    add_option(TDOMF_VERSION_CURRENT,TDOMF_BUILD);
+
+    // Some defaults for new options!
+    add_option(TDOMF_OPTION_MODERATION,true);
+    add_option(TDOMF_OPTION_PREVIEW,true);
+    add_option(TDOMF_OPTION_TRUST_COUNT,-1);
+    add_option(TDOMF_OPTION_YOUR_SUBMISSIONS,true);
     add_option(TDOMF_OPTION_WIDGET_MAX_WIDTH,500);
-    add_option(TDOMF_OPTION_WIDGET_MAX_LENGTH,400);
-  }
-
-  // Pre 0.9.3 (beta)/16
-  if(intval(get_option(TDOMF_VERSION_CURRENT)) < 16) {
-    add_option(TDOMF_OPTION_YOUR_SUBMISSIONS,true);
-  }
-
+    add_option(TDOMF_OPTION_WIDGET_MAX_HEIGHT,400);
+  }
+
+  // Pre 0.9.3 (beta)/16
+  if(intval(get_option(TDOMF_VERSION_CURRENT)) < 16) {
+    add_option(TDOMF_OPTION_YOUR_SUBMISSIONS,true);
+  }
+
   // Pre WP 2.5/0.10.2
   if(intval(get_option(TDOMF_VERSION_CURRENT)) < 26) {
     add_option(TDOMF_OPTION_WIDGET_MAX_WIDTH,500);
-    add_option(TDOMF_OPTION_WIDGET_MAX_LENGTH,400);
+    add_option(TDOMF_OPTION_WIDGET_MAX_HEIGHT,400);
   }
 
   if(get_option(TDOMF_OPTION_VERIFICATION_METHOD) == false) {
@@ -852,14 +852,14 @@
       }
   }
 
-  // Update build number
-  if(get_option(TDOMF_VERSION_CURRENT) != TDOMF_BUILD) {
-    update_option(TDOMF_VERSION_LAST,get_option(TDOMF_VERSION_CURRENT));
-    update_option(TDOMF_VERSION_CURRENT,TDOMF_BUILD);
-  }
-}
-
-tdomf_db_create_tables();
-tdomf_load_widgets();
-
-?>
+  // Update build number
+  if(get_option(TDOMF_VERSION_CURRENT) != TDOMF_BUILD) {
+    update_option(TDOMF_VERSION_LAST,get_option(TDOMF_VERSION_CURRENT));
+    update_option(TDOMF_VERSION_CURRENT,TDOMF_BUILD);
+  }
+}
+
+tdomf_db_create_tables();
+tdomf_load_widgets();
+
+?>
